﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Telerik.Windows.Data;
using System.Windows.Input;

namespace WpfApplication1
{
    public class ViewModel : INotifyPropertyChanged
    { 
        public event PropertyChangedEventHandler PropertyChanged;

        ObservableCollection<Order_Detail> source = new ObservableCollection<Order_Detail>();
        VirtualQueryableCollectionView vqcv;
        private Order_Detail selectedItem;
        internal object internalSelectedItem;
        private NorthwindEntities context;
        
        public Order_Detail SelectedItem
        {
            get
            {
                return this.selectedItem;
            }
            set
            {
                if (value != this.selectedItem)
                {
                    this.selectedItem = value;
                    this.OnPropertyChanged("SelectedItem");
                }
            }
        }

        public VirtualQueryableCollectionView MySource
        {
            get
            {
                vqcv.CollectionChanged += vqcv_CollectionChanged;
                return vqcv;

            }
        }

        void vqcv_CollectionChanged(object sender, System.Collections.Specialized.NotifyCollectionChangedEventArgs e)
        {
            if (e.Action == System.Collections.Specialized.NotifyCollectionChangedAction.Reset)
            { 
            }
            //throw new NotImplementedException();
        }

        public ViewModel()
        {
            context = new NorthwindEntities();
            var query = context.Order_Details.OrderBy(o => o.OrderID);

            vqcv = new VirtualQueryableCollectionView(query) { LoadSize = 20 };
        }
       
        protected virtual void OnPropertyChanged(PropertyChangedEventArgs args)
        {
            PropertyChangedEventHandler handler = this.PropertyChanged;
            if (handler != null)
            {
                handler(this, args);
            }
        }

        private void OnPropertyChanged(string propertyName)
        {
            this.OnPropertyChanged(new PropertyChangedEventArgs(propertyName));
        }
    }
}